//---------------------------------------------------------------------------------------
// - ̍ - 
//---------------------------------------------------------------------------------------
// PC Engine6chgĉo炵B
// G~[^PSP6chgĉoɂ̓CJiĈB
// ȁ`łHI͂˂Achʂƃ^C~OH
// Ȃ悤ɂɂ́A6ch̉Zďo͂̂B
// 16bitf[^6Z16bitꍇ̂ŕt32bitŌvẐB
// TEhobt@16bit16bitɐ؂l߂̂B
//---------------------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------------------
//  monõ\[X͓mFĂ܂BԂ񓮂ƎvǁB
//---------------------------------------------------------------------------------------

#if defined(SOUND)

#include "stdinc.h"
#include "string.h"
#include "syscall.h"
#include "pce.h"
#include "sound.h"
#include "pg.h"
#include "main.h"

void   pgaSetChannelCallback(int channel, void *callback);

static int mseq(DWORD *rand_val);
int    WriteBuffer2(int ch, DWORD dwSize);
void   WriteSoundData(int ch, DWORD dwSize);

// internal 
static int CycleLimit;            // (1byte)ɕKvȍŏClockl (7160000/44100=162.3582...) 덷܂
                                  // 71600000/441=16235.82ɂΎ኱x邩...

int sound_enable=1;               // 0:Sound Off / 1:Sound On
//int sound_stable=1;               // Auto Sound Stabilizer(0:off/1:on)

#define    SAMPLE_RATE    ((DWORD)44100)// sampling rate
#define    SAMPLE10       (SAMPLE_RATE*10)

//------------------------------------------------------------------------------
// Buffer Size
//------------------------------------------------------------------------------
#define    SND_FRMSIZE    736     // 1 frame sound data size (=44100/59.94)
#define    SND_BNKSIZE    512     // buffer read size (see pg.c)
#define    SND_CHMAX      2       // 2ch (=stereo)

//------------------------------------------------------------------------------
// overflow / underflow control
//------------------------------------------------------------------------------
#define    SND_UNDERLIMIT   ( 2*SND_FRMSIZE*SND_CHMAX) // underflow limit :  23(ms)
#define    SND_OVERLIMIT    (10*SND_FRMSIZE*SND_CHMAX) // overflow  limit : 110(ms)

//------------------------------------------------------------------------------
// Sound Ring Buffer Size
//------------------------------------------------------------------------------
#define    SND_RNGSIZE    (20*SND_BNKSIZE) // =400(ms)
//#define    SND_RNGSIZE    (SND_FRMSIZE*SND_BNKSIZE*SND_CHMAX)

//------------------------------------------------------------------------------
// Ōɏ^C~OoƂ
//------------------------------------------------------------------------------
static DWORD dwOldPos[6]={0,0,0,0,0,0};
static DWORD CycleOld[6]={0,0,0,0,0,0};

//------------------------------------------------------------------------------
// 16bit Sound Ring Buffer
//------------------------------------------------------------------------------
static int   snd_lm[6]={0,0,0,0,0,0};   // 1 cycle make buffer limit
static int   snd_wr[6]={0,0,0,0,0,0};   // Sound Write Pointer
static int   snd_rd[6]={0,0,0,0,0,0};   // Sound Read  Pointer
static short sndbuffer[6][SND_RNGSIZE][2]; // Sound Ring Buffer
static int   over_rd=0;
//static int   unlk_wr=0;
static int   unlk_rd=0;    // (Debug) unlock error

//------------------------------------------------------------------------------
// debug 
//------------------------------------------------------------------------------
static int   snd_sound_skip=0;       // sound write skip (overflow limit check)
static int   snd_vsync_skip=0;       // underflow vsync skip counter
static int   snd_frame_skip=0;       // underflow frame skip counter

// internal function
static int    bufLen(int ch);
//static short *bufSetLock(int ch,int size);
//static void   bufSetUnlock(int ch,void* p,int size);
static short *bufGetLock(int ch,int size);
static void   bufGetUnlock(int ch,void* p,int size);

void bufSet(register int ch, register short lch, register short rch)
{
    if(snd_lm[ch]>0) {
        register int wp = snd_wr[ch];
        register int wpn= (wp+1) % SND_RNGSIZE;
        
        if(wpn!=snd_rd[ch]) {
            sndbuffer[ch][wp][0] = lch;
            sndbuffer[ch][wp][1] = rch;
            snd_wr[ch]=(wp+1) % SND_RNGSIZE;
        }

        snd_lm[ch]--;
    }
}



//------------------------------------------------------------------------------
// rest table
//------------------------------------------------------------------------------
void reset_sound(void)
{
    _memset(dwOldPos,0,sizeof(dwOldPos));
    _memset(CycleOld,0,sizeof(CycleOld));
}

//------------------------------------------------------------------------------
// enable or disable
//------------------------------------------------------------------------------
void enable_sound(int mode)
{
    if(mode) {
        if(sound_enable==0) {
            reset_sound();
        }
        sound_enable=1;
    }
    else {
        sound_enable=0;
    }
}


//------------------------------------------------------------------------------
// Init Parameter
//------------------------------------------------------------------------------
void initSound(void)
{
    int i;

    _memset(snd_wr,0,sizeof(snd_wr));
    _memset(snd_rd,0,sizeof(snd_rd));
    _memset(sndbuffer,0,sizeof(sndbuffer));
    _memset(CycleOld ,0,sizeof(CycleOld) );
    _memset(dwOldPos ,0,sizeof(dwOldPos) );

    for(i=0;i<6;i++) {
        snd_lm[i]= SND_FRMSIZE;
    }
}

//------------------------------------------------------------------------------
// Cleanup Parameter
//------------------------------------------------------------------------------
void closeSound(void)
{
    
}

//------------------------------------------------------------------------------
// buffer̒Qbc
//------------------------------------------------------------------------------
static int bufLen(int ch)
{
    register int rd=snd_rd[ch];
    register int wr=snd_wr[ch];
    if(wr==rd) return 0;
    if(wr >rd) return wr-rd;;
    return SND_RNGSIZE - rd + wr;
}

/*
//------------------------------------------------------------------------------
// ɏމf[^̈Qbc֐
// ۂɃQbcAhX͖ߒlgĂق
//------------------------------------------------------------------------------
static short *bufSetLock(int size)
{
    int p = (snd_wr+size)%SND_RNGSIZE;

    if(p!=snd_rd) {
        return &sndbuffer[snd_wr];
    }
    over_wr++;
    
    return 0;
}

//------------------------------------------------------------------------------
// [Write] bN
//------------------------------------------------------------------------------
static void bufSetUnlock(void*ptr,int size)
{
    if( ptr==(void*)&sndbuffer[snd_wr] ) {
        snd_wr=(snd_wr+size)%SND_RNGSIZE;
    } else {
        unlk_wr++;
    }
}
*/

//------------------------------------------------------------------------------
// Sound Ring Buffer特f[^E
//------------------------------------------------------------------------------
static short *bufGetLock(int ch, int size)
{
    if(bufLen(ch)>=size) { // Kvȏ̃f[^邩H
        return &sndbuffer[ch][snd_rd[ch]][0];
    }
    over_rd++;
    return 0;
}

//------------------------------------------------------------------------------
// [Read] 
//------------------------------------------------------------------------------
static void bufGetUnlock(int ch,void* ptr,int size)
{
    if(ptr==(void*)&sndbuffer[ch][snd_rd[ch]]) {
        snd_rd[ch]=(snd_rd[ch]+size)%SND_RNGSIZE;
    } else {
        unlk_rd++;
    }
}

extern int skip_next_frame;
extern int skip_next_vsync;

//------------------------------------------------------------------------------
//ÿ艻z
// TEh쐬ԂɍȂꍇ...
// (1)VSYNCOFFɂĂ݂B
// (2)FRAMESKIPONɂĂ݂B
// ȏ̂Q_Ŋ撣Ă݂B
//------------------------------------------------------------------------------
int SoundStabilizer(void)
{
    // auto sound stabilizer ?
    //if( sound_stable ) {
    if(eConf.skip==5) {
        if(bufLen(0)<=SND_UNDERLIMIT) {
            if(skip_next_vsync==0) {
                skip_next_vsync++;
                snd_vsync_skip++;
            } else {
                skip_next_frame++;
                snd_frame_skip++;
            }
        } else {
            skip_next_vsync=0;
            skip_next_frame=0;
        }
    } else {
        skip_next_vsync=0;
    }
    
    return ((skip_next_frame+skip_next_vsync)>0);
}

//------------------------------------------------------------------------------
// 1/60bԊuŎsė~֐
// 6ch̉
//------------------------------------------------------------------------------
void SoundProcessing(void)
{
    if(sound_enable) {
        register int i;

        for(i=0;i<6;i++) {
            WriteSoundData(0,SND_FRMSIZE);
            
            snd_lm[i] = SND_FRMSIZE;
        
            // buffer overflow limit Ȃǉ
            if(bufLen(i)<SND_OVERLIMIT) {
                snd_wr[i] = (snd_wr[i] + (SND_FRMSIZE*SND_CHMAX)) % SND_RNGSIZE;
            }else {
                snd_sound_skip++;
            }
        }
        
        for(i=0;i<6;i++) {
            sceKernelWakeupThread(pga_threadhandle[i]);
        }

    }
}


//------------------------------------------------------------------------------
// Emulation corepsgɕωƂf[^
// ƂĂ΂֐
//------------------------------------------------------------------------------
void write_psg(int ch)
{
    if(sound_enable) {
        register int Cycle = (DWORD)M.User - CycleOld[ch];
        
    	// I[o[t[^C~OŕςɂȂ邩Ȃ
        if(Cycle<0) {
            CycleOld[ch] = (DWORD)M.User;
        } else {
            // TEhf[^WriteԊu臒l𒴂Ă邩H
            if(Cycle>CycleLimit) {
                register DWORD dwNewPos = Cycle/CycleLimit;
                //WriteBuffer2(ch, (dwNewPos-dwOldPos[ch]));
                dwOldPos[ch] = dwNewPos;
            }
        }
    }
}

//------------------------------------------------------------------------------
//
//
//------------------------------------------------------------------------------
static int mseq(DWORD *rand_val)
{
	if (*rand_val & 0x00080000)	{
		*rand_val = ((*rand_val ^ 0x0004) << 1) + 1;
		return 1;
	} else {
		*rand_val <<= 1;
		return 0;
	}
}

//------------------------------------------------------------------------------
// dwSize1ch̃TCYw肷邱
// CH̑ǗWriteBufferŎ߂
//------------------------------------------------------------------------------
void WriteSoundData(int ch, DWORD dwNewPos)
{
    if(sound_enable) { 
        if(dwOldPos[ch] < dwNewPos){
            WriteBuffer2(ch, (dwNewPos-dwOldPos[ch]));
        }
        
        CycleOld[ch] = (DWORD)M.User;
        dwOldPos[ch] = 0;
    }
}

#if 1 ////***************************************************************************/
int WriteBuffer2(int ch, DWORD dwSize)
{
#define	N	32
    //int i;
	static DWORD n[6] = {0,0,0,0,0,0};
	static DWORD k[6] = {0,0,0,0,0,0};
	static DWORD r[6];
	static DWORD rand_val[6] = {0,0,0,0,0x51F631E4,0x51F631E4};
	/* a*2^(b*x) */
	/* a = 400, b = log2(16384/a), x = 0.0 ~ 1.0 */
	static int	 vol_tbl[32] = {
		 100, 451, 508,  573,  646,  728,  821,  925,
		1043,1175,1325, 1493, 1683, 1898, 2139, 2411,
		2718,3064,3454, 3893, 4388, 4947, 5576, 6285,
		7085,7986,9002,10148,11439,12894,14535,16384,
	};
    register int lvol, rvol;
    
    if(dwSize==0) {
        return 0;
    }

    return 0;
    
	if (!(io.PSG[ch][4]&0x80)) {
		n[ch] = k[ch] = 0;
        for(;dwSize;dwSize--) { bufSet(ch,0,0); }
        return 0;
	}

    /* make volume data from table & register*/
    {
        int psgv = io.psg_volume;
        int psg4 = io.PSG[ch][4] & 0x1f;
        int psg5 = io.PSG[ch][5];
        
        lvol = ((psgv>>3)&0x1E) + psg4 + ((psg5>>3)&0x1E) - 60;
        if(lvol<0) lvol = vol_tbl[0];
        else       lvol = vol_tbl[lvol];
        
        rvol = ((psgv<<1)&0x1E) + psg4 + ((psg5<<1)&0x1E) - 60;
        if (rvol<0) rvol = vol_tbl[0];
        else        rvol = vol_tbl[rvol];
    }
    
    if (io.PSG[ch][4]&0x40) {
        register int wav0 = ((short)io.wave[ch][0]-16)*702;
       
        lvol = (int)wav0*lvol>>14;
        rvol = (int)wav0*rvol>>14;
        
        for(;dwSize;dwSize--) {
            bufSet(ch,lvol,rvol);
        }
        
	} else {
        if (ch >= 4 && (io.PSG[ch][7]&0x80)) {
            register DWORD ra = r[ch];
            register DWORD ka = k[ch];
            int ra7020l=(7020*lvol)>>14;
            int ra7020r=(7020*rvol)>>14;
            register int sndL=(ra?ra7020l:-ra7020l);
            register int sndR=(ra?ra7020r:-ra7020r);
            register DWORD T;
            register DWORD Np = (io.PSG[ch][7]&0x1F);
            
            Np = 3000 + (Np<<9);
            
            for(;dwSize;dwSize--) {
                ka += Np;
                T = ka / (DWORD)SAMPLE_RATE;
                if(T >= 1) {
                    ra = mseq(&rand_val[ch]);
                    ka -= SAMPLE_RATE*T;
                    sndL=(ra?+ra7020l:-ra7020l);
                    sndR=(ra?+ra7020r:-ra7020r);
                }
                bufSet(ch,sndL,sndR);
            }
            
            r[ch]=ra;
            k[ch]=ka;
            return 0;
        }
        else {
            WORD wave[32];
            register DWORD T;
            register DWORD NTp = io.PSG[ch][2]+((DWORD)io.PSG[ch][3]<<8);

            if (NTp==0) {
                for(;dwSize;dwSize--) { bufSet(ch,0,0); }
                return 0;;
            }
            
            for(T=0;T<32;T++) {
                wave[T] = ((short)io.wave[ch][T]-16)*702;
            }

            {
                register DWORD na = n[ch];
                register DWORD ka = k[ch];
                register int wavena;
                
                NTp = (32*1118608)/NTp;
                
                for(;dwSize;dwSize--) {
                    wavena = wave[na];
                    bufSet(ch,((int)(short)wavena*lvol>>14),((int)(short)wavena*rvol>>14));
                    ka += NTp;
                    T = ka/SAMPLE10;
                    na = (na+T)&31;
                    ka -= SAMPLE10*T;
                }
                
                n[ch]=na;
                k[ch]=ka;
            }
        }
    }
}

#endif////***************************************************************************/

//------------------------------------------------------------------------------
// Sound Player Thread main function
//------------------------------------------------------------------------------
void* wavout_snd_callback(int ch,short *buf, unsigned long reqn)
{
    static short *src=0;
    int buflen;

    if(sound_enable) {
        if(src) {
            bufGetUnlock(ch,src,reqn);
            src=0;
        }
    
        for(buflen=bufLen(ch);
            buflen<(reqn*SND_CHMAX*2); // (2005.07.01) ̌H
            buflen=bufLen(ch) ) {
            sceKernelSleepThread(); // if no sound buffer, sleep...
        }
        src = bufGetLock(ch,reqn);
        return src;
    }

    return 0;
}

void* wavout_snd0_callback(short *buf, unsigned long reqn) { return wavout_snd_callback(0,buf,reqn); }
void* wavout_snd1_callback(short *buf, unsigned long reqn) { return wavout_snd_callback(1,buf,reqn); }
void* wavout_snd2_callback(short *buf, unsigned long reqn) { return wavout_snd_callback(2,buf,reqn); }
void* wavout_snd3_callback(short *buf, unsigned long reqn) { return wavout_snd_callback(3,buf,reqn); }
void* wavout_snd4_callback(short *buf, unsigned long reqn) { return wavout_snd_callback(4,buf,reqn); }
void* wavout_snd5_callback(short *buf, unsigned long reqn) { return wavout_snd_callback(5,buf,reqn); }


//------------------------------------------------------------------------------
//
// Sound Initialize
// 
//------------------------------------------------------------------------------
int wavoutInit(void)
{
    // Sound data 1bytêɕKvCycleԊu
    CycleLimit = BaseClock / SAMPLE_RATE;

    // setup thread function
    pgaSetChannelCallback(0,wavout_snd0_callback);
    pgaSetChannelCallback(1,wavout_snd1_callback);
    pgaSetChannelCallback(2,wavout_snd2_callback);
    pgaSetChannelCallback(3,wavout_snd3_callback);
    pgaSetChannelCallback(4,wavout_snd4_callback);
    pgaSetChannelCallback(5,wavout_snd5_callback);
    
#ifdef CDEMULATION
    pgaSetChannelCallback(1,wavout_snd1_callback);
#endif// CDEMULATION
    return 0;
}

//------------------------------------------------------------------------------
//
// Sound Close
// 
//------------------------------------------------------------------------------
int wavoutClose(void)
{
    return 1;
}



//------------------------------------------------------------------------------
// fobOp̕\Ȃ
//------------------------------------------------------------------------------
void dbgSound(void)
{
    int sy=100;
    mh_print     (0,sy,"Sound",RGB_WHITE);  sy+=10;
    mh_print_hex8(0,sy,snd_wr[0],RGB_YELLOW);  sy+=10;
    mh_print_hex8(0,sy,snd_rd[0],RGB_YELLOW);  sy+=10;

    mh_print_hex8(0,sy,snd_sound_skip,RGB_BLUE);  sy+=10;
    mh_print_hex8(0,sy,snd_vsync_skip,RGB_RED);   sy+=10;
    mh_print_hex8(0,sy,snd_frame_skip,RGB_RED);   sy+=10;
}


#endif // defined(SOUND)


