//------------------------------------------------------------------------------
//
// L[͂邽߂̃t@C
//
//
//------------------------------------------------------------------------------

#include "stdinc.h"
#include "syscall.h"
#include "pg.h"
#include "main.h"
#include "pce.h"


#define CTRL_EXIT  (CTRL_SELECT|CTRL_LTRIGGER)

extern int exit_flag;
extern EmuRuntime eRun;
extern EmuConfig  eConf;

static int keycvt[8]={JOY_A,JOY_B,JOY_C,JOY_D,JOY_E,JOY_F,JOY_START,JOY_SELECT};
static int pspcvt[6]={CTRL_CROSS,CTRL_CIRCLE,CTRL_SQUARE,CTRL_TRIANGLE,CTRL_LTRIGGER,CTRL_RTRIGGER};

static ctrl_data_t paddata;

//--------------------------------------------------------------------------
// Key Input
// pg.creadpad֐gĂGȏ͕svȂ̂Œڏ邱Ƃ...
//
//--------------------------------------------------------------------------
int JoyStick(short* JS)
{
    register int i;
	register short js = 0;
	register int   bt = 0;

    JS[0] = JS[1] = JS[2] = JS[3] = JS[4] = 0;

    if(pgPSP()) {
        sceCtrlPeek(&paddata,1);
        bt = paddata.buttons;
        // analogPCE07̃\[Xq : AiO͂}ChɂȂB
        if(paddata.analog[CTRL_ANALOG_X] < 127-84) bt |= CTRL_LEFT;
        if(paddata.analog[CTRL_ANALOG_X] > 127+84) bt |= CTRL_RIGHT;
        if(paddata.analog[CTRL_ANALOG_Y] < 127-84) bt |= CTRL_UP;
        if(paddata.analog[CTRL_ANALOG_Y] > 127+84) bt |= CTRL_DOWN;
    } else {
        sceCtrlRead(&paddata,1);
        bt = paddata.buttons;
    }
	
    if(bt) {
        if( bt&CTRL_DOWN  )  js |= JOY_DOWN;
        if( bt&CTRL_UP    )  js |= JOY_UP;
        if( bt&CTRL_RIGHT )  js |= JOY_RIGHT;
        if( bt&CTRL_LEFT  )  js |= JOY_LEFT;
        if( bt&CTRL_START )  js |= JOY_START;
        if( bt&CTRL_SELECT)  js |= JOY_SELECT;
        
        for(i=0;i<6;i++) {
            if((pspcvt[i]&bt)) {
                if(eConf.rapid[i]==0) {
                    js |= keycvt[eConf.key[i]];
                    eRun.rapid[i]=0;
                } else {
                    if(eRun.rapid[i]==eConf.rapid[i]) {
                        js |= keycvt[eConf.key[i]];
                        eRun.rapid[i]=0;
                    } else {
                        eRun.rapid[i]++;
                    }
                }
            }
        }

        if(eConf.button6) {
        	js |= JOY_SIX;
        }

        if((bt&CTRL_EXIT)==CTRL_EXIT) {
            switch(menu_Main()){
              case STATE_QUIT:
                exit_flag=1;
              case STATE_ROM:
                return 0x10000;
                break;
              default:
				  js = 0;
                break;
            }
            js=0;
        }
        eConf.padno=0;
        JS[eConf.padno] = js;
    }

    if(exit_flag) {
        return 0x10000;
    }
    
    return 0;
}

